-- pomocne tabulky --

insert into mena (first_name)
values	('Laura'), ('Andrej'), ('Veronika'), ('Jessica'), ('Bystrik'),
		('John'), ('Ralph'), ('Jacob'), ('Corey'), ('Tyrone'),
		('Robert'), ('Lawrence'), ('Lee'), ('Herman'), ('Darren'),
		('Michael'), ('Nicholas'), ('Melvin'), ('Maurice'), ('Lonnie'),
		('William'), ('Roy'), ('Alfred'), ('Vernon'), ('Lance'),
		('David'), ('Benjamin'), ('Kyle'), ('Roberto'), ('Cody');

-- last names

insert into priezviska (last_name)
values	('Smith'), ('Jones'), ('Taylor'), ('Williams'), ('Brown'),
		('Davies'), ('Evans'), ('Wilson'), ('Thomas'), ('Roberts'),
		('Johnson'), ('Lewis'), ('Walker'), ('Robinson'), ('Wood'),
		('Thompson'), ('White'), ('Watson'), ('Jackson'), ('Wright'),
		('Green'), ('Harris'), ('Cooper'), ('King'), ('Lee'),
		('Martin'), ('Clarke'), ('James'), ('Morgan'), ('Hughes'),
		('Edwards'), ('Hill'), ('Moore'), ('Clark'), ('Harrison'),
		('Scott'), ('Young'), ('Morris'), ('Hall'), ('Ward'),
		('Turner'), ('Carter'), ('Phillips'), ('Mitchell'), ('Patel'),
		('Adams'), ('Campbell'), ('Anderson'), ('Allen'), ('Cook');
		
insert into timy (nazov)
values	('Manchester United'), ('Real Madrid'), ('Manchester City'), ('Chelsea'), ('Liverpool'),
		('Tottenham'), ('Arsenal'), ('Barcelona'), ('Atletico Madrid'), ('Bilbao'),
		('Valencia'), ('Juventus'), ('AC Milano'), ('Inter'), ('Rim'),
		('Slovan Bratislava'), ('Zilina'), ('Trencin'), ('Zlate Moravce'), ('Spartak Vrable'),
		('TJ Zitavce');
		
---- hlavne tabulky
insert into kancelaria (kredit,login,heslo)
values('1000000','kancelaria','kancelaria');
---- bookmakers
with data as ( 
	select	tmp1.i, tmp2.i, -- aby subselecty nevratili tie iste riadky
			first_name,
			last_name,
			floor(random() * (1000 - 50) + 50) as zetony		
	from generate_series(1, 100) as seq(i)
	cross join lateral (select seq.i, * from mena order by random() limit 1) as tmp1
	cross join lateral (select seq.i, * from priezviska order by random() limit 1) as tmp2
)

insert into bookmaker (meno, priezvisko, zetony)
select first_name, last_name, zetony from data;

insert into bookmaker (meno,priezvisko,zetony,login,heslo)
values('bookmaker','bookmaker','1000000','bookmaker','bookmaker');

update bookmaker set  login = concat(meno, id), heslo = concat(meno, id);

---- uzivatelia
with data as ( 
	select	tmp1.i, tmp2.i,
			first_name,
			last_name,
			first_name || '.' || last_name || '@gmail.com' as email,
			date '1950-01-01' + floor(random()*18000)::integer as datumnar,
			floor(random() * (1000 - 50) + 50) as money,
			floor(random() * (1000 - 50) + 50) as bods,
			1 as cislo			
	from generate_series(1, 100) as seq(i)
	cross join lateral (select seq.i, * from mena order by random() limit 1) as tmp1
	cross join lateral (select seq.i, * from priezviska order by random() limit 1) as tmp2
)

insert into uzivatelia (meno, priezvisko, email, narodenie,bod,kredit,cislo_tiketu)
select first_name, last_name, email,  datumnar, bods, money,cislo from data;
 
update uzivatelia set  login = concat(meno, id), heslo = concat(meno, id);
-- select concat(meno, id) as meno, concat(meno,id) as heslo from uzivatelia; 
-- vygenerovanie loginu a hesla

--poradit ohladom generovania
with data as ( 
	select
			timestamp '2018-01-01 00:00:00' + random() * (timestamp '2019-01-01 00:00:00' - timestamp '2018-01-01 00:00:00') as prvy,			
			floor(random() * (99) + 1) as bookmaker,
			floor(random() * (50)) as pocet			
	from generate_series(1, 300) as seq(i)
)

insert into udalost (id_bookmaker, datum_konania, pocetpodani)
select bookmaker, prvy, pocet from data;
update udalost set  koniec_stavkovania = (udalost.datum_konania - INTERVAL '1' HOUR);

with data as ( 
	select	tmp1.i, tmp2.i,
			tmp1.nazov as prvy,
			tmp2.nazov as druhy,
			tmp1.i as udalost,
			(random() * (4)+1) as doma,
			(random() * (4)+1) as remi,	
			(random() * (4)+1) as hos		
	from generate_series(1, 100) as seq(i)
	cross join lateral (select seq.i, * from timy order by random() limit 1) as tmp1
	cross join lateral (select seq.i, * from timy order by random() limit 1) as tmp2
)

insert into zapas (id_udalost, domaci, hostia,dom,rem,hos)
select udalost, prvy, druhy, doma, remi, hos from data;

with data as ( 
	select	tmp1.i,
			tmp1.nazov as prvy,
			tmp1.i as udalost,
			(random() * (5)+3) as doma,
			(random() * (5)+2) as remi,	
			(random() * (5)+1) as hos		
	from generate_series(101, 200) as seq(i)
	cross join lateral (select seq.i, * from timy order by random() limit 1) as tmp1
)

insert into umiestnenie (id_udalost, sutaziaci, prvy,dotri,dopat)
select udalost, prvy, doma, remi, hos from data;

with data as ( 
	select	tmp1.i, tmp2.i,
			tmp1.nazov as prvy,
			tmp2.nazov as druhy,
			tmp1.i as udalost,
			(random() * (4)+1) as doma,
			(random() * (4)+1) as remi,	
			(random() * (4)+1) as hos,
			(random() * (4)+1) as ppp				
	from generate_series(201, 300) as seq(i)
	cross join lateral (select seq.i, * from timy order by random() limit 1) as tmp1
	cross join lateral (select seq.i, * from timy order by random() limit 1) as tmp2
)

insert into pocetgolov (id_udalost, domaci, hostia, najviacjeden, dvatri, styripat,viacakopat)
select udalost, prvy, druhy, doma, remi, hos, ppp from data;



/*
insert into udalost (id_bookmaker, datum_konania, koniec_stavkovania,pocetpodani)--doplnit datumy
values (1,'2018-04-29 00:00:00','2018-04-29 09:00:00',3),
(1,'2018-04-29 11:00:00','2018-04-29 10:00:00',4),
(1,'2018-04-29 10:00:00','2018-04-29 09:00:00',3),
(1,'2018-05-29 10:00:00','2018-05-29 09:00:00',0),
(1,'2018-05-29 10:00:00','2018-05-29 09:00:00',1),
(1,'2018-04-29 09:00:00','2018-04-29 08:00:00',0),
(1,'2018-04-21 10:00:00','2018-04-21 09:00:00',0),
(1,'2018-04-23 10:00:00','2018-04-23 09:00:00',0),
(1,'2018-04-23 10:00:00','2018-04-12 09:00:00',0),
(1,'2018-04-22 10:00:00','2018-04-22 09:00:00',0),
(1,'2018-04-22 10:00:00','2018-04-22 09:00:00',0),
(1,'2018-04-22 10:00:00','2018-04-22 09:00:00',0),
(1,'2018-04-22 10:00:00','2018-04-22 09:00:00',0);

--poradit ohladom generovania
insert into zapas (id_udalost, domaci, hostia,dom,rem,hos, spravne)
values (1, 'Real Madrid', 'Manchester United', 2.3, 3.00, 4.00,null),
(2, 'Manchester United', 'Manchester City', 1.80, 3.30, 3.80,null),
(3, 'Juventus', 'Real Madrid', 4.10, 3.50, 1.53,null),
(4, 'AC Milano', 'Rim', 2.50, 3.10, 2.35,null),
(5, 'Liverpool', 'Tottenham', 2.00, 3.60, 1.65,null),
(6, 'Valencia', 'Atletico', 1.05, 3.25, 6.10,null),
(7, 'Manchester United', 'Juventus', 1.55, 2.82, 2.55,1),
(8, 'Real Madrid', 'Manchester City', 2.00, 2.81, 2.02,1);

insert into umiestnenie (id_udalost, sutaziaci, prvy, dotri, dopat,spravne)
values (9, 'Real Madrid' ,6.00, 5.00, 4.00, 1),
(10, 'Manchester United',7.80, 6.30, 4.80, 4),
(11, 'Juventus', 4.10, 3.50, 1.53, 6);

insert into pocetgolov (id_udalost, domaci, hostia, najviacjeden, dvatri, styripat,viacakopat, spravne)--doplnit datumy
values (12, 'Liverpool', 'Tottenham', 2.00, 3.60, 1.65, 1.66, 4),
(13, 'Manchester United', 'Juventus', 1.55, 2.82, 2.55, 1.66, 1);


--poradit ohladom generovania
insert into tiket (id_uzivatel, suma, podany, id_udalost, tip, cislo_tiketu)
values (1, 20.00, 1, 2, 1, 1),
(2, 10.00, 1, 1, 1, 1),
(2, 10.00, 1, 2, 2, 1),
(2, 10.00, 1, 3, 2, 1),
(3, 25.00, 1, 5, 0, 1),
(4, 30.00, 1, 1, 1, 1),
(4, 30.00, 1, 2,2, 1),
(4, 30.00, 1, 3,2, 1),
(2, 100.00, 1, 1,0, 2),
(2, 100.00, 1, 2, 0, 2),
(2, 100.00, 1, 3, 0, 2);

insert into operacie (id_uzivatel, datum,suma,typ)--doplnit datumy
values (1,'2018-01-22',100,1),
(2,'2017-04-22',100,0),
(3, '2018-02-22',100,1);
*/

